var Mocha = require('mocha')
  , fs = require('fs')
  , path = require('path')
  , glob = require('glob')

require('should')

var mocha = new Mocha()
  , counts =
    { total: 0
    , pass: 0
    , fail: 0
    }

// set a timeout
mocha.timeout(6000)

var filter = process.argv[2] || false

function addFile(filepath) {

  if (filepath.indexOf('node_modules') !== -1) {
    return false
  }

  // Only run tests that match filter
  if (filter && (filepath.indexOf(filter) === -1)) {
    return false
  }
  var nicePath = './' + path.relative(__dirname, filepath)

  if (fs.existsSync(filepath)) {
    console.log('Adding tests', nicePath)
    mocha.addFile(filepath)
  } else {
    console.log('Tests not found', nicePath)
  }
  return
}

mocha.reporter('spec').ui('bdd')

var testPaths = [ __dirname + '/../**/*.test.js' ]
  , tests = [].concat.apply([], testPaths.map(function (path) { return glob.sync(path) }))

tests.map(addFile)

var runner = mocha.run(function () {
  console.log('Finished', counts)
  process.exit(counts.fail === 0 ? 0 : 1)
})

runner.on('pass', function () {
  counts.total += 1
  counts.pass += 1
})

runner.on('fail', function () {
  counts.total += 1
  counts.fail += 1
})
